#include <iostream>
#include <string>

using namespace std;

int main(){
int n,m;
cin >> n >> m;
long long int a[n][m];
for(int i=0;i<n;i++) for(int j=0;j<m;j++) cin >> a[i][j];
long long int  res=0;
int x=0,y=0;
if(n==2){
        int desno=0;
    for(int i=y+1;i<m;i++) desno+=a[x][i];
    cout << desno;
    return 0;
    res+=desno;
}
while(x!=n-1 || y!=m-1){
       // cout << x << " x y " << y << endl;
        a[x][y]=0;
    long long int desno=0,dole=0;
    for(int i=x+1;i<n;i++) dole+=a[i][y];
    for(int i=y+1;i<m;i++) desno+=a[x][i];
    if(dole>desno){
        x++;
        res+=desno;

        //cout << "desno " << desno << endl;
       for(int i=y+1;i<m;i++) {
        a[x][i]+=a[x-1][i];
        a[x-1][i]=0;
       }
    }
    else{
        y++;
        res+=dole;
       // cout << "dole " << dole << endl;
       for(int i=x+1;i<m;i++){
        a[i][y]+=a[i][y-1];
        a[i][y-1]=0;
       }
    }

}
cout << res << endl;
return 0;
}